## optee-client 3.16.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.4)
project (optee_client C)

# https://cmake.org/Wiki/CMake_Useful_Variables
set (CMAKE_TOOLCHAIN_FILE CMakeToolchain.txt)

set (CFG_WERROR 1 CACHE BOOL "Build with -Werror")

include(GNUInstallDirs)

################################################################################
# Compiler flags:
#   We want to use the same flags in the entire optee_client git
################################################################################
add_compile_options (
	-Wall -Wbad-function-cast -Wcast-align
	-Werror-implicit-function-declaration -Wextra
	-Wfloat-equal -Wformat-nonliteral -Wformat-security
	-Wformat=2 -Winit-self -Wmissing-declarations
	-Wmissing-format-attribute -Wmissing-include-dirs
	-Wmissing-noreturn -Wmissing-prototypes -Wnested-externs
	-Wpointer-arith -Wshadow -Wstrict-prototypes
	-Wswitch-default -Wunsafe-loop-optimizations
	-Wwrite-strings -fPIC
)
if(CFG_WERROR)
    add_compile_options(-Werror)
endif(CFG_WERROR)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

add_subdirectory (libteec)
add_subdirectory (tee-supplicant)
add_subdirectory (public)
add_subdirectory (libckteec)
add_subdirectory (libseteec)

=== Makefile ===
# Public variables are stored in config.mk
include ./config.mk

#########################################################################
# Set Internal Variables						#
# May be modified to match your setup                                   #
#########################################################################
ifneq ($(V),1)
VPREFIX := @
endif
export VPREFIX

EXPORT_DIR ?= $(O)/export
DESTDIR ?= $(EXPORT_DIR)
SBINDIR ?= /usr/sbin
LIBDIR ?= /usr/lib
INCLUDEDIR ?= /usr/include

.PHONY: all build build-libteec build-libckteec build-libseteec install copy_export \
	clean cscope clean-cscope \
	checkpatch-pre-req checkpatch-modified-patch checkpatch-modified-file \
	checkpatch-last-commit-patch checkpatch-last-commit-file \
	checkpatch-base-commit-patch checkpatch-base-commit-file \
	checkpatch-all-files distclean

all: build install

build-libteec:
	@echo "Building libteec.so"
	@$(MAKE) --directory=libteec --no-print-directory --no-builtin-variables \
			CFG_TEE_BENCHMARK=$(CFG_TEE_BENCHMARK) CFG_TEE_CLIENT_LOG_LEVEL=$(CFG_TEE_CLIENT_LOG_LEVEL)

build-tee-supplicant: build-libteec
	@echo "Building tee-supplicant"
	$(MAKE) --directory=tee-supplicant  --no-print-directory --no-builtin-variables CFG_TEE_SUPP_LOG_LEVEL=$(CFG_TEE_SUPP_LOG_LEVEL)

build: build-libteec build-tee-supplicant build-libckteec build-libseteec

build-libckteec: build-libteec
	@echo "Building libckteec.so"
	@$(MAKE) --directory=libckteec --no-print-directory --no-builtin-variables

build-libseteec: build-libteec
	@echo "Building libseteec.so"
	@$(MAKE) --directory=libseteec --no-print-directory --no-builtin-variables

install: copy_export

clean: clean-libteec clean-tee-supplicant clean-cscope clean-libckteec clean-libseteec

clean-libteec:
	@$(MAKE) --directory=libteec --no-print-directory clean

clean-tee-supplicant:
	@$(MAKE) --directory=tee-supplicant --no-print-directory clean

clean-libckteec:
	@$(MAKE) --directory=libckteec --no-print-directory clean

clean-libseteec:
	@$(MAKE) --directory=libseteec --no-print-directory clean

cscope:
	@echo "  CSCOPE"
	${VPREFIX}find ${CURDIR} -name "*.[chsS]" > cscope.files
	${VPREFIX}cscope -b -q -k

clean-cscope:
	${VPREFIX}rm -f cscope.*

# Various checkpatch targets. The ones ending with "patch" only considers the
# patch, whilst the ones ending with "file" checks the complete file.
# +-------------------------------+------------+----------------------------+
# | Target commit                 | File/Patch | Comment                    |
# +-------------------------------+------------+----------------------------+
# | checkpatch-modified-patch     | Patch      | Check local modifications  |
# +-------------------------------+------------+----------------------------+
# | checkpatch-modified-file      | File       | Check Local modifications  |
# +-------------------------------+------------+----------------------------+
# | checkpatch-last-commit-patch  | Patch      | Check against HEAD^        |
# +-------------------------------+------------+----------------------------+
# | checkpatch-last-commit-file   | File       | Check against HEAD^        |
# +-------------------------------+------------+----------------------------+
# | checkpatch-base-commit-patch  | Patch      | Against specic commit      |
# +-------------------------------+------------+----------------------------+
# | checkpatch-base-commit-file   | File       | Against specic commit      |
# +-------------------------------+------------+----------------------------+
# | checkpatch-all-files          | File       | Check all tracked files    |
# +-------------------------------+------------+----------------------------+
CHECKPATCH_IGNORE	?= --ignore NEW_TYPEDEFS --no-signoff
CHECKPATCH_STRICT	?= --strict
CHECKPATCH_ARGS		?= $(CHECKPATCH_IGNORE) $(CHECKPATCH_STRICT) --no-tree --terse
CHECKPATCH_PATCH_ARGS   := $(CHECKPATCH_ARGS) --patch
CHECKPATCH_FILE_ARGS 	:= $(CHECKPATCH_ARGS) --file --no-patch

checkpatch-pre-req:
	@echo "  CHECKPATCH"
ifndef CHECKPATCH
	$(error "Environment variable CHECKPATCH must point to Linux kernels checkpatch script")
else
ifeq (,$(wildcard ${CHECKPATCH}))
	$(error "CHECKPATCH points to the incorrect file")
endif
endif

checkpatch-modified-patch: checkpatch-pre-req
	${VPREFIX}git diff | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-modified-file: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only)


checkpatch-last-commit-patch: checkpatch-pre-req
	${VPREFIX}git diff HEAD^ | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-last-commit-file: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only HEAD^)


checkpatch-base-commit-patch: checkpatch-pre-req
ifndef BASE_COMMIT
	$(error "Environment variable BASE_COMMIT must contain a valid commit")
endif
	${VPREFIX}git diff $(BASE_COMMIT) | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-base-commit-file: checkpatch-pre-req
ifndef BASE_COMMIT
	$(error "Environment variable BASE_COMMIT must contain a valid commit")
endif
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only ${BASE_COMMIT})

checkpatch-all-files: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git ls-files)

distclean: clean

copy_export: build
	mkdir -p $(DESTDIR)$(SBINDIR) $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCLUDEDIR)
	cp config.mk $(DESTDIR)/$(INCLUDEDIR)/optee_client_config.mk
	cp -a ${O}/libteec/libteec.so* $(DESTDIR)$(LIBDIR)
	cp -a ${O}/libteec/libteec.a $(DESTDIR)$(LIBDIR)
	cp ${O}/tee-supplicant/tee-supplicant $(DESTDIR)$(SBINDIR)
	cp public/*.h $(DESTDIR)$(INCLUDEDIR)
	cp libckteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
	cp -a ${O}/libckteec/libckteec.so* $(DESTDIR)$(LIBDIR)
	cp -a ${O}/libckteec/libckteec.a $(DESTDIR)$(LIBDIR)
	cp libseteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
	cp -a ${O}/libseteec/libseteec.so* $(DESTDIR)$(LIBDIR)
	cp -a ${O}/libseteec/libseteec.a $(DESTDIR)$(LIBDIR)

=== tee-supplicant/CMakeLists.txt ===
project (tee-supplicant C)

################################################################################
# Configuration flags always included
################################################################################
option (CFG_TA_TEST_PATH "Enable tee-supplicant to load from test/debug path" OFF)
option (RPMB_EMU "Enable tee-supplicant to emulate RPMB" ON)
option (CFG_TA_GPROF_SUPPORT "Enable tee-supplicant support for TAs instrumented with gprof" ON)
option (CFG_FTRACE_SUPPORT "Enable tee-supplicant support for TAs instrumented with ftrace" ON)
option (CFG_TEE_SUPP_PLUGINS "Enable tee-supplicant plugin support" ON)

set (CFG_TEE_SUPP_LOG_LEVEL "1" CACHE STRING "tee-supplicant log level")
# FIXME: Question is, is this really needed? Should just use defaults from # GNUInstallDirs?
set (CFG_TEE_CLIENT_LOAD_PATH "/lib" CACHE STRING "Location of libteec.so")
set (CFG_TEE_FS_PARENT_PATH "/data/tee" CACHE STRING "Location of TEE filesystem (secure storage)")
# FIXME: Why do we have if defined(CFG_GP_SOCKETS) && CFG_GP_SOCKETS == 1 in the c-file?
set (CFG_GP_SOCKETS "1" CACHE STRING "Enable GlobalPlatform Socket API support")
set (CFG_TEE_PLUGIN_LOAD_PATH "/usr/lib/tee-supplicant/plugins/" CACHE STRING "tee-supplicant's plugins path")

if (CFG_TEE_SUPP_PLUGINS)
	set (CMAKE_INSTALL_RPATH "${CFG_TEE_PLUGIN_LOAD_PATH}")
endif()

################################################################################
# Source files
################################################################################
set (SRC
	src/handle.c
	src/hmac_sha2.c
	src/rpmb.c
	src/sha2.c
	src/tee_supp_fs.c
	src/tee_supplicant.c
	src/teec_ta_load.c
)

if (CFG_GP_SOCKETS)
	set (SRC ${SRC} src/tee_socket.c)
endif()

if (CFG_TA_GPROF_SUPPORT OR CFG_FTRACE_SUPPORT)
	set (SRC ${SRC} src/prof.c)
endif()

if (CFG_TEE_SUPP_PLUGINS)
	set (SRC ${SRC} src/plugin.c)
endif()

################################################################################
# Built binary
################################################################################
add_executable (${PROJECT_NAME} ${SRC})

################################################################################
# Flags always set
################################################################################
target_compile_definitions (${PROJECT_NAME}
	PRIVATE -DCFG_TEE_SUPP_LOG_LEVEL=${CFG_TEE_SUPP_LOG_LEVEL}
	PRIVATE -DTEEC_LOAD_PATH="${CFG_TEE_CLIENT_LOAD_PATH}"
	PRIVATE -DTEE_FS_PARENT_PATH="${CFG_TEE_FS_PARENT_PATH}"
	PRIVATE -DBINARY_PREFIX="TSUP"
)

################################################################################
# Optional flags
################################################################################
if (CFG_GP_SOCKETS)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_GP_SOCKETS=${CFG_GP_SOCKETS})
endif()

if (CFG_TA_TEST_PATH)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_TA_TEST_PATH=${CFG_TA_TEST_PATH})
endif()

if (RPMB_EMU)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DRPMB_EMU=1)
endif()

if (CFG_TA_GPROF_SUPPORT)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_TA_GPROF_SUPPORT)
endif()

if (CFG_FTRACE_SUPPORT)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_FTRACE_SUPPORT)
endif()

if (CFG_TEE_SUPP_PLUGINS)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DTEE_SUPP_PLUGINS
		PRIVATE -DTEE_PLUGIN_LOAD_PATH="${CFG_TEE_PLUGIN_LOAD_PATH}"
	)
endif()

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(${PROJECT_NAME} PRIVATE src)

target_link_libraries (${PROJECT_NAME}
	PRIVATE teec
	PRIVATE optee-client-headers
)

if (CFG_TEE_SUPP_PLUGINS)
	target_link_libraries (${PROJECT_NAME}
		PRIVATE dl
	)
endif()

################################################################################
# Install targets
################################################################################
install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})

=== tee-supplicant/Makefile ===
include ../flags.mk
include ../config.mk

OUT_DIR := $(OO)/tee-supplicant

# Emulate RPMB ioctl's by default
RPMB_EMU	?= 1

.PHONY: all tee-supplicant clean

all: tee-supplicant
################################################################################
# Teec configuration
################################################################################
PACKAGE_NAME	:= tee-supplicant

TEES_SRCS	:= tee_supplicant.c \
		   teec_ta_load.c \
		   tee_supp_fs.c \
		   rpmb.c \
		   handle.c

ifeq ($(CFG_GP_SOCKETS),y)
TEES_SRCS 	+= tee_socket.c
endif

ifeq ($(RPMB_EMU),1)
TEES_SRCS	+= sha2.c hmac_sha2.c
endif
ifneq (,$(filter y,$(CFG_TA_GPROF_SUPPORT) $(CFG_FTRACE_SUPPORT)))
TEES_SRCS	+= prof.c
endif

ifeq ($(CFG_TEE_SUPP_PLUGINS),y)
TEES_SRCS 	+= plugin.c
endif

TEES_SRC_DIR	:= src
TEES_OBJ_DIR	:= $(OUT_DIR)
TEES_OBJS 	:= $(patsubst %.c,$(TEES_OBJ_DIR)/%.o, $(TEES_SRCS))
TEES_INCLUDES 	:= ${CURDIR}/../libteec/include \
		   ${CURDIR}/src \
		   ${CURDIR}/../public \

TEES_CFLAGS	:= $(addprefix -I, $(TEES_INCLUDES)) $(CFLAGS) \
		   -DDEBUGLEVEL_$(CFG_TEE_SUPP_LOG_LEVEL) \
		   -DBINARY_PREFIX=\"TEES\" \
		   -DTEE_FS_PARENT_PATH=\"$(CFG_TEE_FS_PARENT_PATH)\" \
		   -DTEEC_LOAD_PATH=\"$(CFG_TEE_CLIENT_LOAD_PATH)\" \

ifeq ($(CFG_GP_SOCKETS),y)
TEES_CFLAGS	+= -DCFG_GP_SOCKETS=1
endif
ifeq ($(RPMB_EMU),1)
TEES_CFLAGS	+= -DRPMB_EMU=1
endif
ifeq ($(CFG_TA_TEST_PATH),y)
TEES_CFLAGS	+= -DCFG_TA_TEST_PATH=1
endif
TEES_FILE	:= $(OUT_DIR)/$(PACKAGE_NAME)
TEES_LFLAGS    := $(LDFLAGS) -L$(OUT_DIR)/../libteec -lteec

ifeq ($(CFG_TA_GPROF_SUPPORT),y)
TEES_CFLAGS	+= -DCFG_TA_GPROF_SUPPORT
endif

ifeq ($(CFG_FTRACE_SUPPORT),y)
TEES_CFLAGS	+= -DCFG_FTRACE_SUPPORT
endif

ifeq ($(CFG_TEE_SUPP_PLUGINS),y)
TEES_CFLAGS	+= -DTEE_SUPP_PLUGINS \
		   -DTEE_PLUGIN_LOAD_PATH=\"$(CFG_TEE_PLUGIN_LOAD_PATH)\"
endif

TEES_LFLAGS	+= -lpthread
# Needed to get clock_gettime() for for glibc versions before 2.17
TEES_LFLAGS	+= -lrt

ifeq ($(CFG_TEE_SUPP_PLUGINS),y)
# Needed to dynamically load user plugins
TEES_LFLAGS	+= -ldl
# Needed for dlopen()
TEES_LFLAGS 	+= -Wl,-rpath=$(CFG_TEE_PLUGIN_LOAD_PATH)
endif

tee-supplicant: $(TEES_FILE)

$(TEES_FILE): $(TEES_OBJS)
	@echo "  LINK    $@"
	$(VPREFIX)$(CC) -o $@ $+ $(TEES_LFLAGS)
	@echo ""

$(TEES_OBJ_DIR)/%.o: $(TEES_SRC_DIR)/%.c
	$(VPREFIX)mkdir -p $(dir $@)
	@echo "  CC      $<"
	$(VPREFIX)$(CC) $(TEES_CFLAGS) $(TEES_CFLAGS_$(notdir $<)) -c $< -o $@

################################################################################
# Cleaning up configuration
################################################################################
clean:
	$(RM) $(TEES_OBJS) $(TEES_FILE)
	$(call rmdir,$(OUT_DIR))

=== libckteec/include/CMakeLists.txt ===
project (libckteec-headers C)

FILE(GLOB INSTALL_HEADERS "*.h")

add_library(${PROJECT_NAME} INTERFACE)

install (FILES ${INSTALL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== libseteec/include/CMakeLists.txt ===
project (libseteec-headers C)

FILE(GLOB INSTALL_HEADERS "*.h")

add_library(${PROJECT_NAME} INTERFACE)

install (FILES ${INSTALL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
optee-client (3.16.0-2) unstable; urgency=low

  * Nothing changed. Just re-upload.
    For previous upload, we add a new package so we have to send binary
    upload to the new queue. This time we upload source-only package.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 07 Feb 2022 10:18:56 +0800

optee-client (3.16.0-1) unstable; urgency=low

  * New upstream release.
    - Add libseteec0 package.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Fri, 04 Feb 2022 23:49:24 +0800

optee-client (3.15.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 14 Nov 2021 17:50:01 +0800

optee-client (3.13.0-1) unstable; urgency=low

  * Initial release (Closes: #868215)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 20 May 2021 09:18:38 +0800

=== debian/control ===
Source: optee-client
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: debhelper-compat (= 12), docbook-xsl, xsltproc
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/OP-TEE/optee_client
Rules-Requires-Root: no

Package: optee-client-dev
Section: libdevel
Architecture: arm64 armhf
Multi-Arch: same
Depends: libckteec0 (= ${binary:Version}),
         libseteec0 (= ${binary:Version}),
         libteec1 (= ${binary:Version}),
         ${misc:Depends}
Description: normal world user space client APIs for OP-TEE (development)
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains the development files OpTEE Client API

Package: libteec1
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libteec library.

Package: libckteec0
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libckteec library.

Package: libseteec0
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 libseteec stands for secure element control.
 .
 This package contains libseteec library.

Package: tee-supplicant
Architecture: arm64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains tee-supplicant executable.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --exclude=.a

override_dh_auto_build: tee-supplicant.8
	dh_auto_build -- LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		CFG_TEE_FS_PARENT_PATH=/var/lib/optee-client/data/tee

override_dh_auto_install:
	dh_auto_install -- LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		CFG_TEE_FS_PARENT_PATH=/var/lib/optee-client/data/tee

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(CURDIR)/out

DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/docbook-xsl/manpages/docbook.xsl
XP     = xsltproc -''-nonet -''-param man.charmap.use.subset "0"

tee-supplicant.8: debian/tee-supplicant.8.xml
	$(XP) $(DB2MAN) $<

## optee-client 3.18.0

=== debian/changelog ===
optee-client (3.18.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sat, 23 Jul 2022 16:23:00 +0200

optee-client (3.17.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 19 Apr 2022 15:27:27 +0800

## optee-client 3.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,4 +37,7 @@
 add_subdirectory (tee-supplicant)
 add_subdirectory (public)
 add_subdirectory (libckteec)
+find_package (PkgConfig REQUIRED)
+pkg_check_modules(uuid REQUIRED IMPORTED_TARGET uuid)
+add_subdirectory (libteeacl)
 add_subdirectory (libseteec)

=== Makefile ===
--- 
+++ 
@@ -16,8 +16,9 @@
 LIBDIR ?= /usr/lib
 INCLUDEDIR ?= /usr/include
 
-.PHONY: all build build-libteec build-libckteec build-libseteec install copy_export \
-	clean cscope clean-cscope \
+.PHONY: all build build-libteec build-libckteec build-libseteec \
+	build-libteeacl check-libuuid install copy_export clean cscope \
+	clean-cscope \
 	checkpatch-pre-req checkpatch-modified-patch checkpatch-modified-file \
 	checkpatch-last-commit-patch checkpatch-last-commit-file \
 	checkpatch-base-commit-patch checkpatch-base-commit-file \
@@ -34,7 +35,8 @@
 	@echo "Building tee-supplicant"
 	$(MAKE) --directory=tee-supplicant  --no-print-directory --no-builtin-variables CFG_TEE_SUPP_LOG_LEVEL=$(CFG_TEE_SUPP_LOG_LEVEL)
 
-build: build-libteec build-tee-supplicant build-libckteec build-libseteec
+build: build-libteec build-tee-supplicant build-libckteec build-libseteec \
+	build-libteeacl
 
 build-libckteec: build-libteec
 	@echo "Building libckteec.so"
@@ -44,9 +46,18 @@
 	@echo "Building libseteec.so"
 	@$(MAKE) --directory=libseteec --no-print-directory --no-builtin-variables
 
+build-libteeacl: check-libuuid
+	@echo "Building libteeacl.so"
+	@$(MAKE) --directory=libteeacl --no-print-directory --no-builtin-variables
+
+check-libuuid:
+	@echo "Finding uuid.pc"
+	pkg-config --atleast-version=2.34 uuid
+
 install: copy_export
 
-clean: clean-libteec clean-tee-supplicant clean-cscope clean-libckteec clean-libseteec
+clean: clean-libteec clean-tee-supplicant clean-cscope clean-libckteec \
+	clean-libseteec clean-libteeacl
 
 clean-libteec:
 	@$(MAKE) --directory=libteec --no-print-directory clean
@@ -59,6 +70,9 @@
 
 clean-libseteec:
 	@$(MAKE) --directory=libseteec --no-print-directory clean
+
+clean-libteeacl:
+	@$(MAKE) --directory=libteeacl --no-print-directory clean
 
 cscope:
 	@echo "  CSCOPE"
@@ -137,13 +151,16 @@
 copy_export: build
 	mkdir -p $(DESTDIR)$(SBINDIR) $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCLUDEDIR)
 	cp config.mk $(DESTDIR)/$(INCLUDEDIR)/optee_client_config.mk
-	cp -a ${O}/libteec/libteec.so* $(DESTDIR)$(LIBDIR)
-	cp -a ${O}/libteec/libteec.a $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libteec/libteec.so* $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libteec/libteec.a $(DESTDIR)$(LIBDIR)
 	cp ${O}/tee-supplicant/tee-supplicant $(DESTDIR)$(SBINDIR)
 	cp public/*.h $(DESTDIR)$(INCLUDEDIR)
 	cp libckteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
-	cp -a ${O}/libckteec/libckteec.so* $(DESTDIR)$(LIBDIR)
-	cp -a ${O}/libckteec/libckteec.a $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libckteec/libckteec.so* $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libckteec/libckteec.a $(DESTDIR)$(LIBDIR)
+	cp libteeacl/include/*.h $(DESTDIR)$(INCLUDEDIR)
+	cp -d ${O}/libteeacl/libteeacl.so* $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libteeacl/libteeacl.a $(DESTDIR)$(LIBDIR)
 	cp libseteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
-	cp -a ${O}/libseteec/libseteec.so* $(DESTDIR)$(LIBDIR)
-	cp -a ${O}/libseteec/libseteec.a $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libseteec/libseteec.so* $(DESTDIR)$(LIBDIR)
+	cp -d ${O}/libseteec/libseteec.a $(DESTDIR)$(LIBDIR)

=== libckteec/CMakeLists.txt ===
project(ckteec
	VERSION 0.1.0
	LANGUAGES C)

################################################################################
# Packages
################################################################################
find_package(Threads REQUIRED)
if(NOT THREADS_FOUND)
	message(FATAL_ERROR "Threads not found")
endif()

include(GNUInstallDirs)

################################################################################
# Source files
################################################################################
set (SRC
	src/pkcs11_api.c
	src/ck_debug.c
	src/ck_helpers.c
	src/invoke_ta.c
	src/pkcs11_processing.c
	src/pkcs11_token.c
	src/serializer.c
	src/serialize_ck.c
)

################################################################################
# Built library
################################################################################
add_library (ckteec ${SRC})

set_target_properties (ckteec PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR}
)

################################################################################
# Flags always set
################################################################################
target_compile_definitions (ckteec
	PRIVATE -D_GNU_SOURCE
	PRIVATE -DBINARY_PREFIX="LT"
)

################################################################################
# Optional flags
################################################################################

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(ckteec
	PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
	$<INSTALL_INTERFACE:include>
	PRIVATE src
)

target_include_directories(teec
	PUBLIC include
)

target_link_libraries (ckteec
	PRIVATE pthread
	PRIVATE teec
	PRIVATE m
)

################################################################################
# Install targets
################################################################################
install (TARGETS ckteec
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_subdirectory(include)

=== libckteec/Makefile ===
include ../flags.mk
include ../config.mk

OUT_DIR := $(OO)/libckteec

.PHONY: all libckteec clean

all: libckteec
install: libckteec

LIB_NAME	:= libckteec
MAJOR_VERSION	:= 0
MINOR_VERSION	:= 1
PATCH_VERSION	:= 0

LIB_MAJOR		:= $(LIB_NAME).so.$(MAJOR_VERSION)
LIB_MAJ_MIN		:= $(LIB_NAME).so.$(MAJOR_VERSION).$(MINOR_VERSION)
LIB_MAJ_MIN_PAT		:= $(LIB_NAME).so.$(MAJOR_VERSION).$(MINOR_VERSION).$(PATCH_VERSION)
LIBCKTEEC_SO_LIBRARY	:= $(LIB_MAJ_MIN_PAT)
LIBCKTEEC_AR_LIBRARY	:= $(LIB_NAME).a

LIBCKTEEC_SRC_DIR	:= src

LIBCKTEEC_SRCS		= pkcs11_api.c
LIBCKTEEC_SRCS		+= ck_debug.c
LIBCKTEEC_SRCS		+= ck_helpers.c
LIBCKTEEC_SRCS		+= invoke_ta.c
LIBCKTEEC_SRCS		+= pkcs11_processing.c
LIBCKTEEC_SRCS		+= pkcs11_token.c
LIBCKTEEC_SRCS		+= serializer.c
LIBCKTEEC_SRCS		+= serialize_ck.c

LIBCKTEEC_INCLUDES	= ${CURDIR}/include
LIBCKTEEC_INCLUDES 	+= ${CURDIR}/../public

LIBCKTEEC_CFLAGS	:= $(addprefix -I, $(LIBCKTEEC_INCLUDES)) \
			$(CFLAGS) -D_GNU_SOURCE -fPIC

LIBCKTEEC_LFLAGS	:= $(LDFLAGS) -L$(OUT_DIR)/../libteec -lteec

LIBCKTEEC_OBJ_DIR	:= $(OUT_DIR)
LIBCKTEEC_OBJS		:= $(patsubst %.c,$(LIBCKTEEC_OBJ_DIR)/%.o, $(LIBCKTEEC_SRCS))

$(LIBCKTEEC_OBJ_DIR)/%.o: ${LIBCKTEEC_SRC_DIR}/%.c
	$(VPREFIX)mkdir -p $(LIBCKTEEC_OBJ_DIR)
	@echo "  CC      $<"
	$(VPREFIX)$(CC) $(LIBCKTEEC_CFLAGS) -c $< -o $@

libckteec: $(OUT_DIR)/$(LIBCKTEEC_SO_LIBRARY)

$(OUT_DIR)/$(LIBCKTEEC_SO_LIBRARY): $(LIBCKTEEC_OBJS)
	@echo "  LINK    $@"
	$(VPREFIX)$(CC) -shared -Wl,-soname,$(LIB_MAJOR) -o $@ $+ $(LIBCKTEEC_LFLAGS)
	@echo ""

libckteec: $(OUT_DIR)/$(LIBCKTEEC_AR_LIBRARY)

$(OUT_DIR)/$(LIBCKTEEC_AR_LIBRARY): $(LIBCKTEEC_OBJS)
	@echo "  AR      $@"
	$(VPREFIX)$(AR) rcs $@ $+

libckteec:
	$(VPREFIX)ln -sf $(LIB_MAJ_MIN_PAT) $(OUT_DIR)/$(LIB_MAJ_MIN)
	$(VPREFIX)ln -sf $(LIB_MAJ_MIN) $(OUT_DIR)/$(LIB_MAJOR)
	$(VPREFIX)ln -sf $(LIB_MAJOR) $(OUT_DIR)/$(LIB_NAME).so

################################################################################
# Cleaning up configuration
################################################################################
clean:
	$(RM) $(LIBCKTEEC_OBJS)
	$(RM) $(OUT_DIR)/$(LIB_MAJ_MIN_PAT)
	$(RM) $(OUT_DIR)/$(LIB_MAJ_MIN)
	$(RM) $(OUT_DIR)/$(LIB_MAJOR)
	$(RM) $(OUT_DIR)/$(LIBCKTEEC_SO_LIBRARY)
	$(RM) $(OUT_DIR)/$(LIBCKTEEC_AR_LIBRARY)
	$(call rmdir,$(OUT_DIR))

=== libseteec/CMakeLists.txt ===
project(seteec
	VERSION 0.1.0
	LANGUAGES C)

################################################################################
# Packages
################################################################################
find_package(Threads REQUIRED)
if(NOT THREADS_FOUND)
	message(FATAL_ERROR "Threads not found")
endif()

include(GNUInstallDirs)

################################################################################
# Source files
################################################################################
set (SRC
	src/se.c
)

################################################################################
# Built library
################################################################################
add_library (seteec ${SRC})

set_target_properties (seteec PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR}
)

################################################################################
# Flags always set
################################################################################
target_compile_definitions (seteec
	PRIVATE -D_GNU_SOURCE
	PRIVATE -DBINARY_PREFIX="LT"
)

################################################################################
# Optional flags
################################################################################

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(seteec
	PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
	$<INSTALL_INTERFACE:include>
	PRIVATE src
)

target_link_libraries (seteec
	PRIVATE pthread
	PRIVATE teec
)

################################################################################
# Install targets
################################################################################
install (TARGETS seteec
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_subdirectory(include)

=== libteeacl/Makefile ===
include ../flags.mk
include ../config.mk

OUT_DIR := $(OO)/libteeacl

.PHONY: all libteeacl clean

all: libteeacl
install: libteeacl

LIB_NAME	:= libteeacl
MAJOR_VERSION	:= 0
MINOR_VERSION	:= 1
PATCH_VERSION	:= 0

LIB_MAJOR		:= $(LIB_NAME).so.$(MAJOR_VERSION)
LIB_MAJ_MIN		:= $(LIB_NAME).so.$(MAJOR_VERSION).$(MINOR_VERSION)
LIB_MAJ_MIN_PAT	:= $(LIB_NAME).so.$(MAJOR_VERSION).$(MINOR_VERSION).$(PATCH_VERSION)
LIBTEEACL_SO_LIBRARY	:= $(LIB_MAJ_MIN_PAT)
LIBTEEACL_AR_LIBRARY	:= $(LIB_NAME).a

LIBTEEACL_SRC_DIR	:= src

LIBTEEACL_SRCS	= group.c
LIBTEEACL_SRCS	+= tee_uuid.c

LIBTEEACL_INCLUDES	= ${CURDIR}/include

LIBTEEACL_CFLAGS	:= $(addprefix -I, $(LIBTEEACL_INCLUDES)) \
			$(shell pkg-config --cflags uuid) \
			$(CFLAGS) -D_GNU_SOURCE -fPIC

LIBTEEACL_LFLAGS	:= $(LDFLAGS) $(shell pkg-config --libs uuid)

LIBTEEACL_OBJ_DIR	:= $(OUT_DIR)
LIBTEEACL_OBJS	:= $(patsubst %.c,$(LIBTEEACL_OBJ_DIR)/%.o, $(LIBTEEACL_SRCS))

$(LIBTEEACL_OBJ_DIR)/%.o: ${LIBTEEACL_SRC_DIR}/%.c
	$(VPREFIX)mkdir -p $(LIBTEEACL_OBJ_DIR)
	@echo "  CC      $<"
	$(VPREFIX)$(CC) $(LIBTEEACL_CFLAGS) -c $< -o $@

libteeacl: $(OUT_DIR)/$(LIBTEEACL_SO_LIBRARY)

$(OUT_DIR)/$(LIBTEEACL_SO_LIBRARY): $(LIBTEEACL_OBJS)
	@echo "  LINK    $@"
	$(VPREFIX)$(CC) -shared -Wl,-soname,$(LIBTEEACL_SO_LIBRARY) -o $@ $+ $(LIBTEEACL_LFLAGS)
	@echo ""

libteeacl: $(OUT_DIR)/$(LIBTEEACL_AR_LIBRARY)

$(OUT_DIR)/$(LIBTEEACL_AR_LIBRARY): $(LIBTEEACL_OBJS)
	@echo "  AR      $@"
	$(VPREFIX)$(AR) rcs $@ $+

libteeacl:
	$(VPREFIX)ln -sf $(LIB_MAJ_MIN_PAT) $(OUT_DIR)/$(LIB_MAJ_MIN)
	$(VPREFIX)ln -sf $(LIB_MAJ_MIN) $(OUT_DIR)/$(LIB_MAJOR)
	$(VPREFIX)ln -sf $(LIB_MAJOR) $(OUT_DIR)/$(LIB_NAME).so

################################################################################
# Cleaning up configuration
################################################################################
clean:
	$(RM) $(LIBTEEACL_OBJS)
	$(RM) $(OUT_DIR)/$(LIB_MAJ_MIN_PAT)
	$(RM) $(OUT_DIR)/$(LIB_MAJ_MIN)
	$(RM) $(OUT_DIR)/$(LIB_MAJOR)
	$(RM) $(OUT_DIR)/$(LIBTEEACL_SO_LIBRARY)
	$(RM) $(OUT_DIR)/$(LIBTEEACL_AR_LIBRARY)
	$(call rmdir,$(OUT_DIR))

=== libteec/CMakeLists.txt ===
project(libteec
	VERSION 1.0.0
	LANGUAGES C)

################################################################################
# Packages
################################################################################
find_package(Threads REQUIRED)
if(NOT THREADS_FOUND)
	message(FATAL_ERROR "Threads not found")
endif()

################################################################################
# Configuration flags always included
################################################################################
option (CFG_TEE_BENCHMARK "Build with benchmark support" OFF)

set (CFG_TEE_CLIENT_LOG_LEVEL "1" CACHE STRING "libteec log level")
set (CFG_TEE_CLIENT_LOG_FILE "/data/tee/teec.log" CACHE STRING "Location of libteec log")

################################################################################
# Source files
################################################################################
set (SRC
	src/tee_client_api.c
	src/teec_trace.c
)

if (CFG_TEE_BENCHMARK)
	set (SRC ${SRC} src/teec_benchmark.c)
endif()

################################################################################
# Built library
################################################################################
add_library (teec ${SRC})

set_target_properties (teec PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR}
)

################################################################################
# Flags always set
################################################################################
target_compile_definitions (teec
	PRIVATE -D_GNU_SOURCE
	PRIVATE -DDEBUGLEVEL_${CFG_TEE_CLIENT_LOG_LEVEL}
	PRIVATE -DTEEC_LOG_FILE="${CFG_TEE_CLIENT_LOG_FILE}"
	PRIVATE -DBINARY_PREFIX="LT"
)

################################################################################
# Optional flags
################################################################################
if (CFG_TEE_BENCHMARK)
	target_compile_definitions (teec PRIVATE -DCFG_TEE_BENCHMARK)
endif()

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(teec PUBLIC include)

target_link_libraries (teec
	PUBLIC ${CMAKE_THREAD_LIBS_INIT} # this is pthreads
	PRIVATE optee-client-headers)

################################################################################
# Install targets
################################################################################
# FIXME: This should in someway harmonize with CFG_TEE_CLIENT_LOAD_PATH
# FIXME: Should we change this to /usr/local/lib?
install (TARGETS teec LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
                      ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")

=== public/CMakeLists.txt ===
project (optee-client-headers C)

################################################################################
# Header files to be exported
################################################################################
FILE(GLOB INSTALL_HEADERS "*.h")

################################################################################
# Built library
################################################################################
add_library(${PROJECT_NAME} INTERFACE)

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(
        teec
        PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:{CMAKE_INSTALL_INCLUDEDIR}>
)

################################################################################
# Install targets
################################################################################
install (FILES ${INSTALL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== tee-supplicant/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 set (CFG_TEE_SUPP_LOG_LEVEL "1" CACHE STRING "tee-supplicant log level")
 # FIXME: Question is, is this really needed? Should just use defaults from # GNUInstallDirs?
-set (CFG_TEE_CLIENT_LOAD_PATH "/lib" CACHE STRING "Location of libteec.so")
+set (CFG_TEE_CLIENT_LOAD_PATH "/lib" CACHE STRING "Colon-separated list of paths where to look for TAs (see also --ta-dir)")
 set (CFG_TEE_FS_PARENT_PATH "/data/tee" CACHE STRING "Location of TEE filesystem (secure storage)")
 # FIXME: Why do we have if defined(CFG_GP_SOCKETS) && CFG_GP_SOCKETS == 1 in the c-file?
 set (CFG_GP_SOCKETS "1" CACHE STRING "Enable GlobalPlatform Socket API support")
@@ -55,7 +55,7 @@
 # Flags always set
 ################################################################################
 target_compile_definitions (${PROJECT_NAME}
-	PRIVATE -DCFG_TEE_SUPP_LOG_LEVEL=${CFG_TEE_SUPP_LOG_LEVEL}
+	PRIVATE -DDEBUGLEVEL_${CFG_TEE_SUPP_LOG_LEVEL}
 	PRIVATE -DTEEC_LOAD_PATH="${CFG_TEE_CLIENT_LOAD_PATH}"
 	PRIVATE -DTEE_FS_PARENT_PATH="${CFG_TEE_FS_PARENT_PATH}"
 	PRIVATE -DBINARY_PREFIX="TSUP"

=== libckteec/include/CMakeLists.txt ===
project (libckteec-headers C)

FILE(GLOB INSTALL_HEADERS "*.h")

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(
        ${PROJECT_NAME}
        INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:{CMAKE_INSTALL_INCLUDEDIR}>
)

install (FILES ${INSTALL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
optee-client (3.19.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 18 Oct 2022 20:08:19 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,12 @@
 Source: optee-client
 Priority: optional
 Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
-Build-Depends: debhelper-compat (= 12), docbook-xsl, xsltproc
+Build-Depends: debhelper-compat (= 12),
+               docbook-xml,
+               docbook-xsl,
+               pkg-config,
+               uuid-dev,
+               xsltproc
 Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/OP-TEE/optee_client

## optee-client 3.21.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,8 @@
 # https://cmake.org/Wiki/CMake_Useful_Variables
 set (CMAKE_TOOLCHAIN_FILE CMakeToolchain.txt)
 
-set (CFG_WERROR 1 CACHE BOOL "Build with -Werror")
+option (CFG_WERROR "Build with -Werror" TRUE)
+option (WITH_TEEACL "Build libteeacl" TRUE)
 
 include(GNUInstallDirs)
 
@@ -20,9 +21,13 @@
 	-Wmissing-format-attribute -Wmissing-include-dirs
 	-Wmissing-noreturn -Wmissing-prototypes -Wnested-externs
 	-Wpointer-arith -Wshadow -Wstrict-prototypes
-	-Wswitch-default -Wunsafe-loop-optimizations
-	-Wwrite-strings -fPIC
+	-Wswitch-default -Wwrite-strings -fPIC
 )
+if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
+    add_compile_options(
+        -Wunsafe-loop-optimizations
+    )
+endif()
 if(CFG_WERROR)
     add_compile_options(-Werror)
 endif(CFG_WERROR)
@@ -37,7 +42,9 @@
 add_subdirectory (tee-supplicant)
 add_subdirectory (public)
 add_subdirectory (libckteec)
-find_package (PkgConfig REQUIRED)
-pkg_check_modules(uuid REQUIRED IMPORTED_TARGET uuid)
-add_subdirectory (libteeacl)
+if(WITH_TEEACL)
+    find_package (PkgConfig REQUIRED)
+    pkg_check_modules(uuid REQUIRED IMPORTED_TARGET uuid)
+    add_subdirectory (libteeacl)
+endif(WITH_TEEACL)
 add_subdirectory (libseteec)

=== Makefile ===
--- 
+++ 
@@ -15,9 +15,14 @@
 SBINDIR ?= /usr/sbin
 LIBDIR ?= /usr/lib
 INCLUDEDIR ?= /usr/include
+sbindir ?= $(SBINDIR)
+libdir ?= $(LIBDIR)
+includedir ?= $(INCLUDEDIR)
+
+WITH_TEEACL ?= 1
 
 .PHONY: all build build-libteec build-libckteec build-libseteec \
-	build-libteeacl check-libuuid install copy_export clean cscope \
+	build-libteeacl install copy_export clean cscope \
 	clean-cscope \
 	checkpatch-pre-req checkpatch-modified-patch checkpatch-modified-file \
 	checkpatch-last-commit-patch checkpatch-last-commit-file \
@@ -35,8 +40,10 @@
 	@echo "Building tee-supplicant"
 	$(MAKE) --directory=tee-supplicant  --no-print-directory --no-builtin-variables CFG_TEE_SUPP_LOG_LEVEL=$(CFG_TEE_SUPP_LOG_LEVEL)
 
-build: build-libteec build-tee-supplicant build-libckteec build-libseteec \
-	build-libteeacl
+build: build-libteec build-tee-supplicant build-libckteec build-libseteec
+ifeq ($(WITH_TEEACL),1)
+build: build-libteeacl
+endif
 
 build-libckteec: build-libteec
 	@echo "Building libckteec.so"
@@ -46,18 +53,17 @@
 	@echo "Building libseteec.so"
 	@$(MAKE) --directory=libseteec --no-print-directory --no-builtin-variables
 
-build-libteeacl: check-libuuid
+build-libteeacl:
 	@echo "Building libteeacl.so"
 	@$(MAKE) --directory=libteeacl --no-print-directory --no-builtin-variables
-
-check-libuuid:
-	@echo "Finding uuid.pc"
-	pkg-config --atleast-version=2.34 uuid
 
 install: copy_export
 
 clean: clean-libteec clean-tee-supplicant clean-cscope clean-libckteec \
-	clean-libseteec clean-libteeacl
+	clean-libseteec
+ifeq ($(WITH_TEEACL),1)
+clean: clean-libteeacl
+endif
 
 clean-libteec:
 	@$(MAKE) --directory=libteec --no-print-directory clean
@@ -149,18 +155,20 @@
 distclean: clean
 
 copy_export: build
-	mkdir -p $(DESTDIR)$(SBINDIR) $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCLUDEDIR)
-	cp config.mk $(DESTDIR)/$(INCLUDEDIR)/optee_client_config.mk
-	cp -d ${O}/libteec/libteec.so* $(DESTDIR)$(LIBDIR)
-	cp -d ${O}/libteec/libteec.a $(DESTDIR)$(LIBDIR)
-	cp ${O}/tee-supplicant/tee-supplicant $(DESTDIR)$(SBINDIR)
-	cp public/*.h $(DESTDIR)$(INCLUDEDIR)
-	cp libckteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
-	cp -d ${O}/libckteec/libckteec.so* $(DESTDIR)$(LIBDIR)
-	cp -d ${O}/libckteec/libckteec.a $(DESTDIR)$(LIBDIR)
-	cp libteeacl/include/*.h $(DESTDIR)$(INCLUDEDIR)
-	cp -d ${O}/libteeacl/libteeacl.so* $(DESTDIR)$(LIBDIR)
-	cp -d ${O}/libteeacl/libteeacl.a $(DESTDIR)$(LIBDIR)
-	cp libseteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
-	cp -d ${O}/libseteec/libseteec.so* $(DESTDIR)$(LIBDIR)
-	cp -d ${O}/libseteec/libseteec.a $(DESTDIR)$(LIBDIR)
+	mkdir -p $(DESTDIR)$(sbindir) $(DESTDIR)$(libdir) $(DESTDIR)$(includedir)
+	cp config.mk $(DESTDIR)/$(includedir)/optee_client_config.mk
+	cp -d ${O}/libteec/libteec.so* $(DESTDIR)$(libdir)
+	cp -d ${O}/libteec/libteec.a $(DESTDIR)$(libdir)
+	cp ${O}/tee-supplicant/tee-supplicant $(DESTDIR)$(sbindir)
+	cp public/*.h $(DESTDIR)$(includedir)
+	cp libckteec/include/*.h $(DESTDIR)$(includedir)
+	cp -d ${O}/libckteec/libckteec.so* $(DESTDIR)$(libdir)
+	cp -d ${O}/libckteec/libckteec.a $(DESTDIR)$(libdir)
+ifeq ($(WITH_TEEACL),1)
+	cp libteeacl/include/*.h $(DESTDIR)$(includedir)
+	cp -d ${O}/libteeacl/libteeacl.so* $(DESTDIR)$(libdir)
+	cp -d ${O}/libteeacl/libteeacl.a $(DESTDIR)$(libdir)
+endif
+	cp libseteec/include/*.h $(DESTDIR)$(includedir)
+	cp -d ${O}/libseteec/libseteec.so* $(DESTDIR)$(libdir)
+	cp -d ${O}/libseteec/libseteec.a $(DESTDIR)$(libdir)

=== libteec/CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,9 @@
 # Built library
 ################################################################################
 add_library (teec ${SRC})
+
+set(libteectgt teec)
+configure_file(libteec.pc.in libteec.pc @ONLY)
 
 set_target_properties (teec PROPERTIES
 	VERSION ${PROJECT_VERSION}

=== debian/changelog ===
optee-client (3.21.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 26 Jun 2023 04:11:50 +0800

optee-client (3.20.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Fri, 23 Jun 2023 02:01:10 +0800

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
 Multi-Arch: same
 Depends: libckteec0 (= ${binary:Version}),
          libseteec0 (= ${binary:Version}),
+         libteeacl0.1.0 (= ${binary:Version}),
          libteec1 (= ${binary:Version}),
          ${misc:Depends}
 Description: normal world user space client APIs for OP-TEE (development)
@@ -29,6 +30,20 @@
  Client API library.
  .
  This package contains the development files OpTEE Client API
+
+Package: libteeacl0.1.0
+Architecture: arm64 armhf
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: normal world user space client APIs for OP-TEE
+ OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
+ non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
+ technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
+ exposed to Trusted Applications and the TEE Client API v1.0, which is the
+ API describing how to communicate with a TEE. This package provides the TEE
+ Client API library.
+ .
+ This package contains libteeacl library.
 
 Package: libteec1
 Architecture: arm64 armhf
